%bcond_with enginio
%bcond_with webengine
%bcond_with webkit

%global python3_dbus_dir %(%{__python3} -c "import dbus.mainloop; print(dbus.mainloop.__path__[0])" 2>/dev/null || echo "%{python3_sitearch}/dbus/mainloop")
%global py3_sipdir %{_datadir}/sip/PyQt5
%global py3_site_qt5 %{python3_sitearch}/PyQt5
%global __provides_exclude_from ^(%{_qt5_plugindir}/.*\\.so)$

Summary:       PyQt5 is a set of Python bindings for Qt5
Name:          python-qt5
Version:       5.15.6
Release:       3%{?dist}
License:       GPLv3
Url:           http://www.riverbankcomputing.com/software/pyqt/
Source0:       https://pypi.python.org/packages/source/P/PyQt5/PyQt5-%{version}.tar.gz
Source1:       macros.pyqt5
Source2:       pylupdate5.sh
Source3:       pyrcc5.sh
Source4:       pyuic5.sh

BuildRequires: make chrpath findutils
BuildRequires: pkgconfig(dbus-1) pkgconfig(dbus-python) qt5-qtbase-private-devel pkgconfig(Qt5Core)
BuildRequires: pkgconfig(Qt5Bluetooth) pkgconfig(Qt5DBus) pkgconfig(Qt5Designer) pkgconfig(Qt5Gui)
BuildRequires: pkgconfig(Qt5Location) pkgconfig(Qt5Multimedia) pkgconfig(libpulse-mainloop-glib)
BuildRequires: pkgconfig(Qt5Nfc) pkgconfig(Qt5Network) pkgconfig(Qt5OpenGL) pkgconfig(Qt5Positioning)
BuildRequires: pkgconfig(Qt5Quick) pkgconfig(Qt5QuickWidgets) pkgconfig(Qt5Sensors) pkgconfig(Qt5SerialPort)
BuildRequires: pkgconfig(Qt5Sql) pkgconfig(Qt5Svg) pkgconfig(Qt5Test) pkgconfig(Qt5X11Extras)
BuildRequires: pkgconfig(Qt5Xml) pkgconfig(Qt5XmlPatterns) pkgconfig(Qt5WebChannel) pkgconfig(Qt5WebSockets)
BuildRequires: python%{python3_pkgversion}-devel python%{python3_pkgversion} python%{python3_pkgversion}-dbus
BuildRequires: python%{python3_pkgversion}-pyqt5-sip python%{python3_pkgversion}-sip-devel
%if %{with enginio}
BuildRequires: pkgconfig(Enginio)
%endif
%{?_qt5:Requires: %{_qt5} = %{_qt5_version}}

%description
PyQt is a set of Python v2 and v3 bindings for The Qt Company's Qt application framework and runs on 
all platforms supported by Qt including Windows, OS X, Linux, iOS and Android. PyQt5 supports Qt v5.

%package rpm-macros
Summary:        RPM macros in python-qt5
BuildArch:      noarch

%description rpm-macros
RPM macros in python-qt5.

%package -n python%{python3_pkgversion}-qt5
Summary:        Python v3 bindings for Qt5
Requires:       python%{python3_pkgversion}-qt5-base = %{version}-%{release}
Provides:       python%{python3_pkgversion}-PyQt5 = %{version}-%{release}
Provides:       python%{python3_pkgversion}-PyQt5 = %{version}-%{release}

%description -n python%{python3_pkgversion}-qt5
Python v3 bindings for Qt5.

%package -n python%{python3_pkgversion}-qt5-base
Summary:        Python v3 bindings for Qt5 base
Requires:       %{name}-rpm-macros = %{version}-%{release} python%{python3_pkgversion}-dbus
%{?_qt5:Requires: %{_qt5} = %{_qt5_version}}
%{?_sip_api:Requires: python%{python3_pkgversion}-pyqt5-sip-api(%{_sip_api_major}) >= %{_sip_api}}
Provides:       python%{python3_pkgversion}-PyQt5-base = %{version}-%{release}
Provides:       python%{python3_pkgversion}-PyQt5-base = %{version}-%{release}

%description -n python%{python3_pkgversion}-qt5-base
Python v3 bindings for Qt5 base.

%package -n python%{python3_pkgversion}-qt5-devel
Summary:        Development files for python3-qt5
Requires:       python%{python3_pkgversion}-qt5 = %{version}-%{release}
Requires:       python%{python3_pkgversion}-sip-devel
Provides:       python%{python3_pkgversion}-PyQt5-devel = %{version}-%{release}

%description -n python%{python3_pkgversion}-qt5-devel
Development files for python3-qt5.

%if %{with webengine}
%package -n python%{python3_pkgversion}-qt5-webengine
Summary:        Python v3 bindings for Qt5 WebEngine
Requires:       python%{python3_pkgversion}-qt5 = %{version}-%{release}
BuildRequires:  qt5-qtwebengine-devel

%description -n python%{python3_pkgversion}-qt5-webengine
Python v3 bindings for Qt5 WebEngine.
%endif

%if %{with webkit}
%package -n python%{python3_pkgversion}-qt5-webkit
Summary:        Python v3 bindings for Qt5 Webkit
BuildRequires:  qt5-qtwebkit-devel qt5-qtwebkit-devel
Requires:       python%{python3_pkgversion}-qt5 = %{version}-%{release}

%description -n python%{python3_pkgversion}-qt5-webkit
Python v3 bindings for Qt5 Webkit.
%endif

%prep
%autosetup -n PyQt5-%{version} -p1

%build
export PATH="%{_qt5_bindir}:$PATH"

mkdir %{_target_platform}-python3
cp -a * %{_target_platform}-python3/ ||:
pushd %{_target_platform}-python3
%{__python3} ./configure.py \
    --assume-shared --confirm-license --no-dist-info --qmake=%{_qt5_qmake} \
    --qsci-api --qsci-api-destdir=%{_qt5_datadir}/qsci \
    %{?py3_sipdir:--sipdir=%{py3_sipdir}} --verbose QMAKE_CFLAGS_RELEASE="%{optflags}" \
    QMAKE_CXXFLAGS_RELEASE="%{optflags} `pkg-config --cflags dbus-python`"\
    QMAKE_LFLAGS_RELEASE="%{?__global_ldflags}"
%make_build
popd

%install
%make_install INSTALL_ROOT=%{buildroot} -C %{_target_platform}-python3
pushd %{buildroot}
%if "%py3_sipdir" == "%{_datadir}/sip/PyQt5"
mkdir -p .%{_datadir}/python3-sip
cp -alf .%{py3_sipdir} .%{_datadir}/python3-sip/PyQt5
%endif
for i in .%{py3_site_qt5}/*.so .%{python3_dbus_dir}/pyqt5.so ; do
    test -x $i  || chmod a+rx $i
done

rm -rfv .%{py3_site_qt5}/uic/port_v2/

install -p -m644 -D %{SOURCE1} .%{_rpmconfigdir}/macros.d/macros.pyqt5
sed -i \
  -e "s|@@NAME@@|%{name}|g" \
  -e "s|@@EPOCH@@|%{?epoch}%{!?epoch:0}|g" \
  -e "s|@@VERSION@@|%{version}|g" \
  -e "s|@@EVR@@|%{?epoch:%{epoch:}}%{version}-%{release}|g" \
  .%{_rpmconfigdir}/macros.d/macros.pyqt5

rm -fv .%{_bindir}/{pyrcc5,pylupdate5,pyuic5}
install -p -m755 -D %{SOURCE2} .%{_bindir}/pylupdate5
install -p -m755 -D %{SOURCE3} .%{_bindir}/pyrcc5
install -p -m755 -D %{SOURCE4} .%{_bindir}/pyuic5
sed -i \
  -e "s|@PYTHON3@|%{__python3}|g" \
  .%{_bindir}/{pyrcc5,pylupdate5,pyuic5}
popd

%files rpm-macros
%defattr(-,root,root)
%{_rpmconfigdir}/macros.d/macros.pyqt5

%files -n python%{python3_pkgversion}-qt5
%defattr(-,root,root)
%{_bindir}/pylupdate5
%{_bindir}/pyrcc5
%{_bindir}/pyuic5
%{_qt5_plugindir}/PyQt5
%{_qt5_plugindir}/designer/libpyqt5.so
%if %{with enginio}
%{py3_site_qt5}/Enginio.*
%endif
%{py3_site_qt5}/QtBluetooth.*
%{py3_site_qt5}/QtDesigner.*
%{py3_site_qt5}/QtHelp.*
%{py3_site_qt5}/QtLocation.*
%{py3_site_qt5}/QtMultimedia.*
%{py3_site_qt5}/QtMultimediaWidgets.*
%{py3_site_qt5}/QtNfc.*
%{py3_site_qt5}/QtPositioning.*
%{py3_site_qt5}/QtQml.*
%{py3_site_qt5}/QtQuick.*
%{py3_site_qt5}/QtQuickWidgets.*
%{py3_site_qt5}/QtSensors.*
%{py3_site_qt5}/QtSerialPort.*
%{py3_site_qt5}/QtSvg.*
%{py3_site_qt5}/QtWebChannel.*
%{py3_site_qt5}/QtWebSockets.*
%{py3_site_qt5}/QtX11Extras.*
%{py3_site_qt5}/QtXmlPatterns.*
%{py3_site_qt5}/uic/
%{py3_site_qt5}/pylupdate.so
%{py3_site_qt5}/pylupdate_main.py*
%{py3_site_qt5}/pyrcc.so
%{py3_site_qt5}/pyrcc_main.py*

%files -n python%{python3_pkgversion}-qt5-base
%license LICENSE
%defattr(-,root,root)
%doc NEWS README
%{python3_dbus_dir}/pyqt5.so
%dir %{py3_site_qt5}/
%{py3_site_qt5}/__pycache__/
%{py3_site_qt5}/__init__.py*
%{py3_site_qt5}/Qt.*
%{py3_site_qt5}/QtCore.*
%{py3_site_qt5}/QtDBus.*
%{py3_site_qt5}/QtGui.*
%{py3_site_qt5}/QtNetwork.*
%{py3_site_qt5}/QtOpenGL.*
%{py3_site_qt5}/QtPrintSupport.*
%{py3_site_qt5}/QtSql.*
%{py3_site_qt5}/QtTest.*
%{py3_site_qt5}/QtWidgets.*
%{py3_site_qt5}/QtXml.*
%{py3_site_qt5}/_QOpenGLFunctions_*

%if %{with webengine}
%files -n python%{python3_pkgversion}-qt5-webengine
%defattr(-,root,root)
%{py3_site_qt5}/QtWebEngine*
%endif

%if %{with webkit}
%files -n python%{python3_pkgversion}-qt5-webkit
%defattr(-,root,root)
%{py3_site_qt5}/QtWebKit*
%endif

%files -n python%{python3_pkgversion}-qt5-devel
%defattr(-,root,root)
%{py3_sipdir}/
%dir %{_datadir}/python3-sip/
%{_datadir}/python3-sip/PyQt5/

%defattr(-,root,root)
%doc examples/
%dir %{_qt5_datadir}/qsci/
%dir %{_qt5_datadir}/qsci/api/
%dir %{_qt5_datadir}/qsci/api/python/
%doc %{_qt5_datadir}/qsci/api/python/PyQt5.api

%changelog
* Fri Apr 28 2023 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 5.15.6-3
- Rebuilt for OpenCloudOS Stream 23.05

* Fri Mar 31 2023 OpenCloudOS Release Engineering <releng@opencloudos.tech> - 5.15.6-2
- Rebuilt for OpenCloudOS Stream 23

* Fri Mar 17 2023 Shuo Wang <abushwang@tencent.com> - 5.15.6-1
- initial build
